DCMTK: DcmQuantPixel Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | Private Attributes | List of all members
DcmQuantPixel Class Reference

objects of this class represent individual RGB pixels. More...

Inheritance diagram for DcmQuantPixel:

## Public Member Functions
| DcmQuantPixel ()
| default constructor, creates black pixel
| DcmQuantPixel (const DcmQuantPixel &arg)
| copy assignment constructor
virtual | ~DcmQuantPixel ()
| destructor
OFBool | operator== (const DcmQuantPixel &src) const
| comparison operator for equality
double | luminance () const
| this method computes the luminance of the current pixel according to the NTSC formula.
unsigned long | hash () const
| this method computes an unsigned long hash value for the current pixel.
DcmQuantComponent | getRed () const
| returns the red component
DcmQuantComponent | getGreen () const
| returns the green component
DcmQuantComponent | getBlue () const
| returns the blue component
void | assign (DcmQuantComponent r, DcmQuantComponent g, DcmQuantComponent b)
| assigns new R, G and B values to this pixel
void | scale (DcmQuantComponent r, DcmQuantComponent g, DcmQuantComponent b, const DcmQuantScaleTable &table)
| assigns new R, G and B values to this pixel using the given scale table in which all three values are looked up.

## Private Attributes
DcmQuantComponent | red
| red color component of this pixel
DcmQuantComponent | green
| green color component of this pixel
DcmQuantComponent | blue
| blue color component of this pixel

## Detailed Description

objects of this class represent individual RGB pixels.

This class is used by the color quantization classes. For efficiency considerations, all methods are declared inline.

## Member Function Documentation

## ◆ assign()

void DcmQuantPixel::assign | ( | DcmQuantComponent | r,
|  | DcmQuantComponent | g,
|  | DcmQuantComponent | b )
| inline

assigns new R, G and B values to this pixel

Parameters

  r | new R
  g | new G
  b | new B

References blue, green, and red.

Referenced by DcmQuantFloydSteinberg::adjust().

## ◆ getBlue()

DcmQuantComponent DcmQuantPixel::getBlue | ( |  | ) | const
| inline

returns the blue component

Returns
  blue component of this pixel

References blue.

Referenced by DcmQuantFloydSteinberg::adjust(), DcmQuantColorTable::computeIndex(), and DcmQuantFloydSteinberg::propagate().

## ◆ getGreen()

DcmQuantComponent DcmQuantPixel::getGreen | ( |  | ) | const
| inline

returns the green component

Returns
  green component of this pixel

References green.

Referenced by DcmQuantFloydSteinberg::adjust(), DcmQuantColorTable::computeIndex(), and DcmQuantFloydSteinberg::propagate().

## ◆ getRed()

DcmQuantComponent DcmQuantPixel::getRed | ( |  | ) | const
| inline

returns the red component

Returns
  red component of this pixel

References red.

Referenced by DcmQuantFloydSteinberg::adjust(), DcmQuantColorTable::computeIndex(), and DcmQuantFloydSteinberg::propagate().

## ◆ hash()

unsigned long DcmQuantPixel::hash | ( |  | ) | const
| inline

this method computes an unsigned long hash value for the current pixel.

The hash algorithm is taken from Jef Poskanzer's ppm utility library. The return value is guaranteed to be < DcmQuantHashSize.

Returns
  hash value for current pixel

References blue, DcmQuantHashSize, green, and red.

Referenced by DcmQuantColorHashTable::item(), and DcmQuantColorHashTable::lookup().

## ◆ luminance()

double DcmQuantPixel::luminance | ( |  | ) | const
| inline

this method computes the luminance of the current pixel according to the NTSC formula.

The range of the luminance equals the range of the underlying DcmQuantComponent type. However, the luminance is returned as a double.

Returns
  luminance of this pixel

References blue, green, and red.

## ◆ scale()

void DcmQuantPixel::scale | ( | DcmQuantComponent | r,
|  | DcmQuantComponent | g,
|  | DcmQuantComponent | b,
|  | const DcmQuantScaleTable & | table )
| inline

assigns new R, G and B values to this pixel using the given scale table in which all three values are looked up.

Parameters

  r | new R
  g | new G
  b | new B
  table | scale table (LUT) in which R, G and B are looked up.

References blue, green, and red.

Referenced by DcmQuantColorMapping< T1, T2 >::create().

The documentation for this class was generated from the following file:

- dcmimage/include/dcmtk/dcmimage/diqtpix.h

Generated on Wed Apr 30 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2